<script lang="ts">
  import { Table, Column } from '@sveltestrap/sveltestrap';
  import { onMount } from 'svelte';
  import { BonusPointsEventQuery } from '@models/BonusPoints';
  import type { BonusPointsReturn, BonusPoints } from '@models/BonusPoints';
  import { Gql } from '@db';
  import { EventRole, type NullableEventRole } from '@auth/models';
  import { eventId, keycloak } from '@stores';

  let bonusPoints: Array<BonusPoints> | null = null;

  let queryRole: NullableEventRole;
  $: queryRole = $keycloak?.getFirstRole([EventRole.SuperAdmin, EventRole.EventAdmin]);

  onMount(() => {
    Gql.subscribeSimple<BonusPointsReturn>(
      `subscription ${BonusPointsEventQuery($eventId)}`,
      (v) => (bonusPoints = v.scoring_bonus_points),
      { queryRole },
    );
  });
</script>

<h6>All other points awarded</h6>

{#if bonusPoints}
  <Table rows={bonusPoints} let:row>
    <Column header="Team ID" width="8rem">
      {row.team.id}
    </Column>
    <Column header="Team name" width="8rem">
      {row.team.name}
    </Column>
    <Column header="Points" width="8rem">
      {row.points}
    </Column>
    <Column header="Category" width="15%">
      {row.category}
    </Column>
    <Column header="Reason">
      {row.reason}
    </Column>
    <Column header="Time">
      {row.time}
    </Column>
  </Table>
{:else}
  <h4>...No other points awarded, yet</h4>
{/if}
